#include <sys/sem.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <stdio.h>
#include <stdlib.h>
#include "semafor.h"

void v(int semid, int semnum) {
	struct sembuf operacja;
	operacja.sem_num = semnum;
	operacja.sem_op = 1;
	operacja.sem_flg = 0;
	if(semop(semid, &operacja, 1) == -1) {
		perror("Błąd podnoszenia semafora");
		exit(1);
	}
}

void p(int semid, int semnum) {
	struct sembuf operacja;
	operacja.sem_num = semnum;
	operacja.sem_op = -1;
	operacja.sem_flg = 0;
	if(semop(semid, &operacja, 1) == -1) {
		perror("Błąd podnoszenia semafora");
		exit(1);
	}
}

