#include <stdio.h>
#include <string.h>
#include <sys/shm.h>
#include <sys/sem.h>

#include "semafor.h"	//załączam plik nagłówkowy z funkcjami p i v

#define MAX_SIZE 4096


int main(int argc, char **argv) 
{
	int semid = semget(0xABC, 1, 0600);
	if(semid == -1)
	{
		perror("Error while creating a semaphore");
		return -1;
	}
	
	int shmid = shmget(0xCBA, MAX_SIZE * sizeof(char), 0660);

	if (shmid == -1)
	{
		perror("Error while creating a shared segment");
		return -1;
	}

	char *addr = (char*) shmat(shmid, NULL, 0);
	if(addr == (char*)-1) 
	{ 
		perror("Error while attaching to a shared segment");
		return -1;
	}

	while(1)
	{
		p(semid, 0);
		printf("%s\n", addr);	//Tutaj można wprowadzić porównania z oczekiwanym 'haaa' i 'hoooo' za pomocą dwóch możliwych podejść:
					//a) if(strcmp(addr,"haaa") != 0)...
					//b) char buf[MAX_SIZE]; 
					//	strncpy(buf,addr, strlen(addr)); 
					//	if( strcmp(buf, "haaa") != 0)...
		v(semid, 0);
	}

	
	return 0;
}
